# Write-The: AI-powered Code Generation and Refactoring Tool

[![PyPI - Version](https://img.shields.io/pypi/v/write-the.svg)](https://pypi.org/project/write-the)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/write-the.svg)](https://pypi.org/project/write-the)

Write-The is an AI-powered code generation and refactoring tool that leverages GPT-4 to help developers automatically write tests, generate documentation, and refactor code. It is designed to streamline the development process, improve code quality, and increase productivity.

-----

**Table of Contents**

- [Features](#Features)
- [Requirements](#Requirements)
- [Installation](#Installation)
- [Usage](#Usage)
- [Roadmap](#Roadmap)
- [Contributing](#Contributing)
- [License](#License)


## Installation

```console
pip install write-the
```

## Features
Write-The offers the following AI-driven features:

- Write-the Docs: Automatically generate documentation for your codebase, including class and function descriptions, parameter explanations, and examples.
- Write-the Tests: Create test cases for your code, ensuring thorough test coverage and better code quality.
- Write-the Refactor: Receive refactoring suggestions, reduce code complexity, optimize performance, and fix bugs.

## Requirements
Python 3.7 or higher
OpenAI api key

## Usage
To use Write-The, run the following commands:

Write-the Docs:
```bash
write-the docs [OPTIONS] [PATH_TO_SOURCE_CODE]
```

Write-the Tests:

```bash
write-the tests [OPTIONS] [PATH_TO_SOURCE_CODE]
```

Write-the Refactor:
```bash
write-the refactor [OPTIONS] [PATH_TO_SOURCE_CODE]
```

For detailed information on available options and parameters, refer to the official documentation.

## Roadmap
For a detailed project roadmap, including planned features, improvements, and milestones, please see our Project Timeline.

## Contributing
We welcome contributions from the community. If you would like to contribute to Write-The, please follow these steps:

- Fork the repository and create a new branch for your feature or bugfix.
- Develop your changes and ensure that your code follows the project's coding standards.
- Create a pull request with a clear description of your changes and any relevant documentation.
- For more information on contributing, please see our Contributing Guide.

## License
`write-the` is distributed under the terms of the [MIT](https://spdx.org/licenses/MIT.html) license.

